#include <cuda_runtime.h>

#include <math.h>
#include <helper_math.h>

#include "BasicDef.h"

// xNg̊OρDʂ͕xNgȂ̂wvf͏0.0D
float4 cross(float4 a, float4 b)
// float a, b; 2̃xNgD
{
	return make_float4(a.y * b.z - a.z * b.y, a.z * b.x - a.x * b.z, a.x * b.y - a.y * b.x, 0.0f);
}

// 4x4s̊|ZD
void mulMM(float4 *a, float4 *b, float4 *result)
// float 4 *a, *b; 4~4sD
// float4 *result; 4~4sDa~b̌ʁD
{
	int i;
	for(i = 0; i < 4; i++) {
		result[i].x = a[0].x * b[i].x + a[1].x * b[i].y + a[2].x * b[i].z + a[3].x * b[i].w;
		result[i].y = a[0].y * b[i].x + a[1].y * b[i].y + a[2].y * b[i].z + a[3].y * b[i].w;
		result[i].z = a[0].z * b[i].x + a[1].z * b[i].y + a[2].z * b[i].z + a[3].z * b[i].w;
		result[i].w = a[0].w * b[i].x + a[1].w * b[i].y + a[2].w * b[i].z + a[3].w * b[i].w;
	}
}

// xNgւ̍s̓KpD
// a~vDʒuxNgxNg̉]ϊɗpD
float4 mulMV(float4 *a, float4 v)
// float4 *a; 4~4sD
// float4 v; ʒuxNgxNgDwvf͖D
{
	return make_float4(a[0].x * v.x + a[1].x * v.y + a[2].x * v.z,
		a[0].y * v.x + a[1].y * v.y + a[2].y * v.z,
		a[0].z * v.x + a[1].z * v.y + a[2].z * v.z, 
		1.0f); // vxNgȂ0.0fԂׂDDD
}

// s̓]uD
// *a_t*a̓]usD
void transM(float4 *a, float4 *a_t)
// float4 *a, *a_t; 4~4sD
{
	a_t[0] = make_float4(a[0].x, a[1].x, a[2].x, a[3].x);
	a_t[1] = make_float4(a[0].y, a[1].y, a[2].y, a[3].y);
	a_t[2] = make_float4(a[0].z, a[1].z, a[2].z, a[3].z);
	a_t[3] = make_float4(a[0].w, a[1].w, a[2].w, a[3].w);
}

// tšvZD
// *a_i*a̋tsD4~4s񂾂]sp̂3~3ƌȂČvZD
void invM(float4 *a, float4 *a_i)
// float4 *a, *a_i; 4~4sD
{
	float delta;
	delta = a[0].x * a[1].y * a[2].z + a[1].x * a[2].y * a[0].z + a[2].x * a[0].y * a[1].z 
		- a[2].x * a[1].y * a[0].z - a[1].x * a[0].y * a[2].z - a[0].x * a[2].y * a[1].z;

	a_i[0].x = (a[1].y * a[2].z - a[2].y * a[1].z) / delta;
	a_i[1].x = (a[2].x * a[1].z - a[1].x * a[2].z) / delta;
	a_i[2].x = (a[1].x * a[2].y - a[2].x * a[1].y) / delta;

	a_i[0].y = (a[2].y * a[0].z - a[0].y * a[2].z) / delta;
	a_i[1].y = (a[0].x * a[2].z - a[2].x  *a[0].z) / delta;
	a_i[2].y = (a[2].x * a[0].y - a[0].x * a[2].y) / delta;

	a_i[0].z = (a[0].y * a[1].z - a[1].y * a[0].z) / delta;
	a_i[1].z = (a[1].x * a[0].z - a[0].x * a[1].z) / delta;
	a_i[2].z = (a[0].x * a[1].y - a[1].x *a [0].y) / delta;
}

// NH[^jI̐ρD
float4 mulQQ(float4 q1, float4 q0)
// float4 q0, a1; NH[^jID
{
	float4 tmp;
	tmp = cross(q1, q0);
	return make_float4(q0.w * q1.x + q1.w * q0.x + tmp.x, 
					   q0.w * q1.y + q1.w * q0.y + tmp.y,
					   q0.w * q1.z + q1.w * q0.z + tmp.z,
					   q0.w * q1.w - (q0.x * q1.x + q0.y * q1.y + q0.z * q1.z));
}

// NH[^jI̐KD
void normQ(float4 *q)
// float4 *q; NH[^jID
{
	float norm;
	norm = sqrt(q->x * q->x + q->y * q->y + q->z * q->z + q->w * q->w);
	if (norm != 0.0f)
		*q = make_float4(q->x / norm, q->y / norm, q->z / norm, q->w / norm);
}

// \[gɗpϐD
float *sort_value;		
int *sort_id;

// NCbN\[gD
// \[g͑ϐsort_value[]̒lɂčsCsort_id[]ւD
void quickSort(int l, int r)
// int l, r; \[g͈͂̍ƉẼCfbNXD
{
	int i, j;
	float pib;
	int tmpi;
	float tmpf;
	if (l < r) {
		pib = sort_value[(l + r) / 2];
		i = l - 1; 
		j = r + 1;
		while (true) {
			while (sort_value[++i] < pib) {};
			while (sort_value[--j] > pib) {};
			if (i >= j) break;
			tmpf = sort_value[i]; sort_value[i] = sort_value[j]; sort_value[j] = tmpf;
			tmpi = sort_id[i]; sort_id[i] = sort_id[j]; sort_id[j] = tmpi;
		}
		quickSort(l, i - 1);
		quickSort(j + 1, r);
	}
}

// Rr@ɂŗLlxNg̎ZoD
void calcJacobi(float a[3][3], float eigen_vec[3][3], float eigen_value[3])
// float a[3][3]; 3~3sD
// float eigen_vec[3][3]; 3̌ŗLlxNgD
// float eigen_value[3]; 3̌ŗLlD
{
	int i, j, p, q;
	float s, t, v, sn, cs, amax;
	float A1[3][3], A2[3][3], X1[3][3], X2[3][3];

	for(i = 0; i < 3; i++) {
		for(j = 0; j < 3; j++) {
			A1[i][j] = a[i][j];
			X1[i][j] = 0.0f;
		}
		X1[i][i] = 1.0f;
	}

	while(true) {
		amax = 0;
		for (i = 0; i < 3; i++) {
			for (j = 0; j < 3; j++) {
				if (i != j && fabs(A1[i][j]) > amax) {
					amax = fabs(A1[i][j]);
					p = i;
					q = j;
				}
			}
		}

		if (fabs(amax) < (EPS)) {
			for (i = 0; i < 3; i++) {
				for (j = 0; j < 3; j++) {
					eigen_vec[i][j] = X1[i][j];
					eigen_value[i] = A1[i][i];
				}
			}
			break;
		} else {
			s = -A1[p][q];
			t = 0.5f * (A1[p][p] - A1[q][q]);
			v = fabs(t) / sqrt(s * s + t * t);
			sn = sqrt(0.5f * (1.0f - v));
			if (s * t < 0.0f)
				sn = -sn;

			cs = sqrt(1.0f - sn * sn);
			for (i = 0; i < 3; i++) {
				for (j = 0; j < 3; j++) {
					A2[i][j] = A1[i][j];
					A2[p][j] = A1[p][j] * cs - A1[q][j] * sn;
					A2[q][j] = A1[q][j] * cs + A1[p][j] * sn;
					A2[i][p] = A1[i][p] * cs - A1[i][q] * sn;
					A2[i][q] = A1[i][q] * cs + A1[i][p] * sn;
					A2[p][p] = A1[p][p] * cs * cs + A1[q][q] * sn * sn - 2.0f * A1[p][q] * sn * cs;
					A2[q][q] = A1[p][p] * sn * sn + A1[q][q] * cs * cs + 2.0f * A1[p][q] * sn * cs; 
					A2[p][q] = 0.0f;
					A2[q][p] = 0.0f;
				}
			}

			for (i = 0; i < 3; i++) {
				for (j = 0; j < 3; j++) {
					if (j == p)
						X2[i][p] = X1[i][p] * cs - X1[i][q] * sn;
					else if(j == q)
						X2[i][q] = X1[i][q] * cs + X1[i][p] * sn;
					else
						X2[i][j] = X1[i][j];
				}
			}

			for (i = 0; i < 3; i++) {
				for (j = 0; j < 3; j++) {
					A1[i][j] = A2[i][j];
					X1[i][j] = X2[i][j];
				}
			}
		}
	}							
}
