#include <stdio.h>

#include <cuda_runtime.h>
#include <math.h>
#include <helper_math.h>

#include <gl/glew.h>
#include <gl/freeglut.h>

#include "BBox.h"
#include "Bounce.h"
#include "BasicDef.h"

// STLf[^̃t@CD
#define STL_FILE "sample.stl"

// EBhȄʒuƏTCYD
#define INIT_X_POS 100
#define INIT_Y_POS 100
#define INIT_WIDTH 768
#define INIT_HEIGHT 768

// EBhE̕ƍD
unsigned int window_width = INIT_WIDTH; 
unsigned int window_height = INIT_HEIGHT; 

// fvOp̘gTCYi̔jD
#define BOX_X 90.0f
#define BOX_Y 90.0f
#define BOX_Z 130.0f 

// fώ@鎋_ʒuD
#define PHI 160.0
#define THETA 20.0
double phi = PHI;
double theta = THETA;

// |S`惂[hD
bool polygon_mode = true;

// }EXD
int mouse_old_x, mouse_old_y;
bool motion_p;

// Aj[V̎ԍ݁D
float anim_dt = 0.01f;
float anim_time = 0.0f;

// \[gɗpϐD
extern float *sort_value;		
extern int *sort_id;

// f̊e\̈ꎞIȋL^pϐD
float4 I[4];

// Ώۂ̃IuWFNgQD
object obj[NUM_OBJECTS];

// _D
extern double point[MAX_NUM_POINTS][3];
extern unsigned int num_points;

// Op`|SD
extern unsigned int triangle[MAX_NUM_TRIANGLES][3];
extern unsigned int num_triangles;

// _ʒuD
extern double eye[3];

// e_̍WƖ@D
float4 *h_vertex;
float4 *h_normal;
float4 *d_vertex;
float4 *d_normal; 

// eIuWFNgɕtWϊf[^D]ړ{sړD
float4 h_rot_pos[NUM_OBJECTS][4];

// h_vertextrianglȇΉ֌WD
unsigned int *h_vertex_to_triangle;

// _obt@IuWFNgD
GLuint poly_pos_vbo;		// WlD
GLuint poly_normal_vbo;	// @D

// OBB؂̃[gm[hD
tree_node *root_node;

// Փ˃f[^D
unsigned int num_col_2OBB;	// Փ˂ĂOBByA̐D
int3 h_col_2OBB_DB[MAX_NUM_CRASH_BBOX_PAIRS][2];	// Փ˂ĂOBByÃf[^(tri_idx0, num_tris0, obj_idx0), (tri_idx1, num_tris1, obj_idx1)D
int3 (*d_col_2OBB_DB)[2];

unsigned int h_col_2OBB_2obj[MAX_NUM_CRASH_BBOX_PAIRS]; // Փ˂ĂOBB̃yAƏՓ˂ĂIuWFNg̃yÅ֌WtD

col_point h_col_point[NUM_OBJECTS * (NUM_OBJECTS - 1) / 2];		// Փ˓_̃f[^D
col_point *d_col_point;
col_info h_col_info[NUM_OBJECTS * (NUM_OBJECTS - 1) / 2];		// Փ˂IuWFNgf[^D

// O`̊֐D
extern float4 cross(float4 a, float4 b);
extern float4 mulMV(float4 *a, float4 b);
extern void invM(float4 *a, float4 *a_i);
extern float4 mulQQ(float4 q0, float4 q1);
extern void normQ(float4 *q);

extern void buildBBoxTree(tree_node *root_node, float4 *h_vertex, unsigned int *h_vertex_to_triangle);
extern void freeBBoxTree(tree_node *node);
extern bool detectColBBoxes(float4 center0, float4 *axis0, float *h0, float4 center1, float4 *axis1, float *h1);
extern void drawBBoxes(int depth, int draw, tree_node *node);

extern bool loadSTLFile(const char* STL_file);

extern void defineViewMatrix(double phi, double theta, unsigned int width, unsigned int height, double margin);

// oD
extern void launchCPUDetectColPolys(unsigned int num_contacts, unsigned int num_col_2OBB, int3 h_col_2OBB_DB[][2], unsigned int h_col_2OBB_2obj[], float4 h_rot_pos[][4], col_point h_col_point[]);
extern void launchGPUDetectColPolys(unsigned int num_contacts, unsigned int num_col_2OBB, int3 h_col_2OBB_DB[][2], unsigned int h_col_2OBB_2obj[], float4 h_rot_pos[][4], col_point h_col_point[]);

// IuWFNgzȕD
void setObjects(void)
{
	unsigned int i, j;

	// SIuWFNgɏʒuȂǂݒD
	for(i = 0; i < NUM_OBJECTS; i++) {

		// OBB؂̃[gm[hZbgD
		obj[i].node = root_node;

		// j[NȃCfbNXZbgD
		obj[i].index = i;

		// ʂ̐ݒD
		obj[i].mass = MASS;

		// ʒuD
		obj[i].pos 
			= make_float4(15.0f * (i % 7) - 40.0f, 20.0f * (i % 7) - 55.0f, 90.0f - 30.0f * (i / 7), 1.0f);

		// ]s̏D
		obj[i].rot[0] = make_float4(1.0f, 0.0f, 0.0f, 0.0f);
		obj[i].rot[1] = make_float4(0.0f, 0.0f, -1.0f, 0.0f);
		obj[i].rot[2] = make_float4(0.0f, 1.0f, 0.0f, 0.0f);
		obj[i].rot[3] = make_float4(0.0f, 0.0f, 0.0f, 1.0f);

		// xD
		obj[i].vel = make_float4(0.0f, 0.0f, 0.0f, 0.0f);

		// xDȌωȂD
		obj[i].accel = make_float4(0.0f, 0.0f, - 6.8f, 0.0f);

		// pxD
		obj[i].omega = make_float4(0.05f * i, 0.0f, 0.0f, 0.0f);

		// ]sɑΉNH[^jȈD
		obj[i].q = make_float4(sqrt(2.0f) / 2.0f, 0.0f, 0.0f, sqrt(2.0f) / 2.0f);

		// vZς݂̊e\̊i[D
		for(j = 0; j < 4; j++)
			obj[i].I[j] = I[j];

		// e\̋tsD
		invM(obj[i].I, obj[i].Iinv);
	}
}

// _Q̏dSD
float4 calcCOG(unsigned int num, double point[][3])
// unsinged int num; _̌D
// double point[][3]; _̍WD
{
	unsigned int i;
	float4 cog;
	cog = make_float4(0.0f, 0.0f, 0.0f, 1.0f);
	for (i = 0; i < num; i++) {
		cog.x += (float)point[i][X];
		cog.y += (float)point[i][Y];
		cog.z += (float)point[i][Z];
	}
	cog.x /= num;
	cog.y /= num;
	cog.z /= num;
	return(cog);
}

// _Q̊e\D
void calcTensor(unsigned int num, double point[][3], float4 cog, float mass, float4 *inertia)
// unsigned int num; _̌D
// double point[][3]; _̍WD
// float4 cog; _Q̏dSD
// float mass; ʁD
// float4 *inertia; e\D3x3sƌȂD
{
	unsigned int i;
	for (i = 0; i < 3; i++)
		inertia[i] = make_float4(0.0f, 0.0f, 0.0f, 0.0f);
	for (i = 0; i < num; i++) {
		inertia[0].x += (float)((mass / num) * ((point[i][Y] - cog.y) * (point[i][Y] - cog.y) + (point[i][Z] - cog.z) * (point[i][Z] - cog.z)));
		inertia[1].y += (float)((mass / num) * ((point[i][Z] - cog.z) * (point[i][Z] - cog.z) + (point[i][X] - cog.x) * (point[i][X] - cog.x)));
		inertia[2].z += (float)((mass / num) * ((point[i][X] - cog.x) * (point[i][X] - cog.x) + (point[i][Y] - cog.y) * (point[i][Y] - cog.y)));
		inertia[0].y -= (float)((mass / num) * (point[i][X] - cog.x) * (point[i][Y] - cog.y));
		inertia[0].z -= (float)((mass / num) * (point[i][Z] - cog.z) * (point[i][X] - cog.x));
		inertia[1].z -= (float)((mass / num) * (point[i][Y] - cog.y) * (point[i][Z] - cog.z));
	}
	inertia[1].x = inertia[0].y;
	inertia[2].x = inertia[0].z;
	inertia[2].y = inertia[1].z;
}

// |SQ̖@vZD
void calcNormal(int num, float4 *vertex, float4 *normal)
// int num; Op`̌D
// float4 *vertex; _̍WD3gɂȂĎOp`̒_\D
// float4 *normal; e_̖@DOp`̎O_ɂ͓@^D
{
	int i;
	float v0[3], v1[3], norm;

	// eOp`|Sɖ@^D
	for(i = 0; i < num; i++) {
		v0[X] = vertex[3 * i + 2].x - vertex[3 * i + 1].x;
		v0[Y] = vertex[3 * i + 2].y - vertex[3 * i + 1].y;
		v0[Z] = vertex[3 * i + 2].z - vertex[3 * i + 1].z;
		v1[X] = vertex[3 * i + 0].x - vertex[3 * i + 1].x;
		v1[Y] = vertex[3 * i + 0].y - vertex[3 * i + 1].y;
		v1[Z] = vertex[3 * i + 0].z - vertex[3 * i + 1].z;

		// @v0~v1D
		normal[3 * i + 1].x = v0[Y] * v1[Z] - v0[Z] * v1[Y];
		normal[3 * i + 1].y = v0[Z] * v1[X] - v0[X] * v1[Z];
		normal[3 * i + 1].z = v0[X] * v1[Y] - v0[Y] * v1[X];

		// KD
		norm = sqrt(normal[3 * i + 1].x * normal[3 * i + 1].x 
			+ normal[3 * i + 1].y * normal[3 * i + 1].y + normal[3 * i + 1].z * normal[3 * i + 1].z);
		normal[3 * i + 1].x /= norm;
		normal[3 * i + 1].y /= norm;
		normal[3 * i + 1].z /= norm;
		normal[3 * i + 1].w = 0.0f;

		// c2_̖@ւ̃Rs[D
		normal[3 * i] = normal[3 * i + 1];
		normal[3 * i + 2] = normal[3 * i + 1];
	}
}

// CUDA֌W̏D
void initCUDA(void)
{
	unsigned int size;

	// _f[^D
	size = 3 * num_triangles * sizeof(float4);
	cudaMalloc((void**)&d_vertex, size);
	cudaMemcpy(d_vertex, h_vertex, size, cudaMemcpyHostToDevice);

	// @f[^D
	size = 3 * num_triangles * sizeof(float4);
	cudaMalloc((void**)&d_normal, size);
	cudaMemcpy(d_normal, h_normal, size, cudaMemcpyHostToDevice);

	// OBB̏Փ˃f[^D
	size = MAX_NUM_CRASH_BBOX_PAIRS * 2 * sizeof(int3);
	cudaMalloc((void**)&d_col_2OBB_DB, size);

	// |S̏Փ˃f[^D
	size = (NUM_OBJECTS * (NUM_OBJECTS - 1) / 2) * sizeof(col_point);
	cudaMalloc((void**)&d_col_point, size);
}

// f̓ǂݍ݂ƏD
void initialize(void)
{
	unsigned int i, j, k;
	float4 cog;

	// STLf̓ǂݍ݁D
    if (!loadSTLFile(STL_FILE)) {
		printf("t@CJ܂");
		return;
	}

	// WlߑSĂ200{D
	for(i = 0; i < num_points; i++) {
		point[i][X] *= 200.0f;
		point[i][Y] *= 200.0f;
		point[i][Z] *= 200.0f;
	}	
	
	// dŠvZD
	cog = calcCOG(num_points, point);

	// dS_ɈړD
	for(i = 0; i < num_points; i++) {
		point[i][X] -= cog.x;
		point[i][Y] -= cog.y;
		point[i][Z] -= cog.z;
	}
	cog = make_float4(0.0f, 0.0f, 0.0f, 1.0f);

	// e\̌vZD
	calcTensor(num_points, point, cog, MASS, I);

	// OBB؂̍\zD
	h_vertex = (float4 *)malloc(3 * num_triangles * sizeof(float4));
	h_vertex_to_triangle = (unsigned int *)malloc(3 * num_triangles * sizeof(unsigned int));
	root_node = (tree_node *)malloc(sizeof(tree_node));
    buildBBoxTree(root_node, h_vertex, h_vertex_to_triangle);

	// f̖@f[^̌vZD
	h_normal = (float4 *)malloc(3 * num_triangles * sizeof(float4));	
	calcNormal(num_triangles, h_vertex, h_normal);

	// CUDA֌W̏D
	initCUDA();

	// SIuWFNgԂɔzuD
	setObjects();
	
	// num_pointspoint[][3]̍ĐݒD̂߂g̐D
	num_points = 8;
	for (i = 0; i < 2; i++) {
		for (j = 0; j < 2; j++) {
			for (k = 0; k < 2; k++) {
				point[4 * i + 2 * j + k][X] = BOX_X * pow(- 1.0f, (int)i);
				point[4 * i + 2 * j + k][Y] = BOX_Y * pow(- 1.0f, (int)j);
				point[4 * i + 2 * j + k][Z] = BOX_Z * pow(- 1.0f, (int)k);
			}
		}
	}
}

// IuWFNg̈ʒuƑx̍XVD
void moveObjects(float dt)
// float dt; ԁD
{
	unsigned int i;
	float4 q_small, q;
	for (i = 0; i < NUM_OBJECTS; i++) {

		// ʒu̍XVD
		obj[i].pos += obj[i].vel * dt;
		obj[i].pos.w = 1.0f;

		// x̍XVD
		obj[i].vel += obj[i].accel * dt;
		obj[i].vel.w = 0.0f;

		// pxNH[^jIɕϊD
		q_small = 0.5f * obj[i].omega * dt;
		q_small.w = 1.0f;
		
		// NH[^jIɂ鍷]D
		q = mulQQ(q_small, obj[i].q);

		// NH[^jI𐳋KL^D
		normQ(&q);
		obj[i].q = q;

		// NH[^jI]sɕϊD
		obj[i].rot[0]
			= make_float4(1.0f - 2.0f * (q.y * q.y + q.z * q.z),
				2.0f * (q.x * q.y + q.z * q.w),
				2.0f * (q.x * q.z - q.y * q.w), 0.0f);
		obj[i].rot[1] 
			= make_float4(2.0f * (q.x * q.y - q.z * q.w),
				1.0f - 2.0f * (q.x * q.x + q.z * q.z),
				2.0f * (q.y * q.z + q.x * q.w), 0.0f);
		obj[i].rot[2] 
			= make_float4(2.0f * (q.x * q.z + q.y * q.w),
				2.0f * (q.y * q.z - q.x * q.w),
				1.0f - 2.0f * (q.x * q.x + q.y * q.y), 0.0f);
		obj[i].rot[3] = make_float4(0.0f, 0.0f, 0.0f, 1.0f);
	}
}

// OBBm̏Փ˔D
void detectColOBBs(object *obj0, tree_node *node0, object *obj1, tree_node *node1)
// object *obj0, *obj1; Փ˃`FbN̑Ώۂ2̃IuWFNgD
// tree_node *node0, *node1; OBB؂̏Փ˃`FbNΏۂ2̃m[hD
{
	unsigned int i;
	float4 center0, center1;
	float4 axis0[4], axis1[4];

	// OBB̒S_ƎO[oWn֕ϊD
	center0 = mulMV(obj0->rot, node0->BBox.center) + obj0->pos;
	center1 = mulMV(obj1->rot, node1->BBox.center) + obj1->pos;
	for (i = 0; i < 3; i++) {
		axis0[i] = mulMV(obj0->rot, node0->BBox.axis[i]);
		axis1[i] = mulMV(obj1->rot, node1->BBox.axis[i]);
	}

	// OBBm̏Փ˔D
	if (detectColBBoxes(center0, axis0, node0->BBox.h, center1, axis1, node1->BBox.h)) {

		// Փ˂ĂƍlꍇD
		// OBB؂̖[OBBm̃P[XD
		if ((node0->node0 == NULL) && (node1->node0 == NULL)) {

			// Փ˃f[^f[^x[XɋL^D
			h_col_2OBB_DB[num_col_2OBB][0] = make_int3(node0->BBox.tri_index, node0->BBox.num_tris, (int)(obj0->index));
			h_col_2OBB_DB[num_col_2OBB][1] = make_int3(node1->BBox.tri_index, node1->BBox.num_tris, (int)(obj1->index));
			num_col_2OBB++;

			// OBBԂɏՓ˂D
			return;
		
			// node0[OBB̃P[XD
		} else if (node0->node0 == NULL) {
			detectColOBBs(obj0, node0, obj1, node1->node0);
			detectColOBBs(obj0, node0, obj1, node1->node1);
	
			// node1[OBB̃P[XD
		} else if (node1->node0 == NULL) {
			detectColOBBs(obj0, node0->node0, obj1, node1);
			detectColOBBs(obj0, node0->node1, obj1, node1);

			// ċAIɉOBB̑g𒲂ׂD
		} else {
			detectColOBBs(obj0, node0->node0, obj1, node1->node0);
			detectColOBBs(obj0, node0->node0, obj1, node1->node1);
			detectColOBBs(obj0, node0->node1, obj1, node1->node0);
			detectColOBBs(obj0, node0->node1, obj1, node1->node1);
		}
	}
}

// |SƕǖʂƂ̏Փ˔D
void detectColPolyBox(BBox OBB, object *obj, int fc_flag, col_info *col_info)
// BBox OBB; ǖʂƏՓ˂ĂOBBD
// object *obj; ǖʂƏՓ˂ĂIuWFNgD
// int fc_flag; Փ˖ʂʂtOD
// col_info *col_info; Փ˓_̏L^\́D
{
	unsigned int i, j;
	float d, dist[3];
	float4 normal;
	float4 v[3];

	// |SƏՓ˂\̂ǖʂ̕𓾂D
	if (fc_flag == 1) {
		normal = make_float4(- 1.0f, 0.0f, 0.0f, 0.0f);
		d = (BOX_X) ;
	} else if (fc_flag == - 1) {
		normal = make_float4(1.0f, 0.0f, 0.0f, 0.0f);
		d = (BOX_X);
	} else if (fc_flag == 2) {
		normal = make_float4(0.0f, - 1.0f, 0.0f, 0.0f);
		d = (BOX_Y);
	} else if (fc_flag == - 2) {
		normal = make_float4(0.0f, 1.0f, 0.0f, 0.0f);
		d = (BOX_Y);
	} else if (fc_flag == 3) {
		normal = make_float4(0.0f, 0.0f, - 1.0f, 0.0f);
		d = (BOX_Z);
	} else if (fc_flag == - 3) {
		normal = make_float4(0.0f, 0.0f, 1.0f, 0.0f);
		d = (BOX_Z);
	}

	// OBB̑S|Sƕʂ̊𒲂ׂD
	for (i = 0; i < OBB.num_tris; i++) {

		// |S̒_O[oW֕ϊD
		for (j = 0; j < 3; j++)
			v[j] = mulMV(obj->rot, h_vertex[OBB.tri_index + i * 3 + j]) + obj->pos;

		// e_ƕʂ̋𒲂ׂD
		for (j = 0; j < 3; j++)
			dist[j] = dot(normal, v[j]) + d;

		// |SSɕʂ̏ォC܂͊Sɉ̎͏Փ˂ƌȂȂD
		if (((dist[0] < 0.0f) && (dist[1] < 0.0f) && (dist[2] < 0.0f))
			|| ((dist[0] > 0.0f) && (dist[1] > 0.0f) && (dist[2] > 0.0f))) {
		} else {

			// Փ˓_̓|S̏dSDW̓O[oWŋL^D
			col_info->pnt = (v[0] + v[1] + v[2]) / 3.0f;
			col_info->nrml = normal;
			col_info->obj0 = obj;

			// 1łՓ˂瑦ɏID
			return;
		}
	}
}

// OBBƕǖʂƂ̏Փ˔D
void detectColOBBBox(object *obj, tree_node *node, col_info *col_info)
// object *obj; Փ˃`FbNΏۂ̃IuWFNgD
// tree_node *node; OBB؂̏Փ˃`FbNΏۂ̃m[hD
// col_info *col_info; Փ˓_̏L^\́D
{
	unsigned int i;
	int fc_flag;
	float4 center; 
	float4 proj, axis[3];

	// OBB̒S_ƎO[oWn֕ϊD
	center = mulMV(obj->rot, node->BBox.center) + obj->pos;
	for (i = 0; i < 3; i++)
		axis[i] = mulMV(obj->rot, node->BBox.axis[i]);

	// OBBO[oWnXY, YZ, ZX̊eʂɓeƂ́C{bNXX, Y, Z̒̔𓾂D
	proj.x = node->BBox.h[X] * fabs(axis[0].x) + node->BBox.h[Y] * fabs(axis[1].x) + node->BBox.h[Z] * fabs(axis[2].x);
	proj.y = node->BBox.h[X] * fabs(axis[0].y) + node->BBox.h[Y] * fabs(axis[1].y) + node->BBox.h[Z] * fabs(axis[2].y);
	proj.z = node->BBox.h[X] * fabs(axis[0].z) + node->BBox.h[Y] * fabs(axis[1].z) + node->BBox.h[Z] * fabs(axis[2].z);

	// BOX̕ǖʂƂ̏Փ˔DBOX̖ʂ͍Wɕsł邱ƁD
	fc_flag = 0;
	if (center.x + proj.x > (BOX_X))
		fc_flag = 1;
	else if(center.x - proj.x < (- BOX_X))
		fc_flag = - 1;
	else if(center.y + proj.y > (BOX_Y))
		fc_flag = 2;		
	else if(center.y - proj.y < (- BOX_Y))
		fc_flag = - 2;
	else if(center.z + proj.z > (BOX_Z)) 
		fc_flag = 3;
	else if(center.z - proj.z < (- BOX_Z))
		fc_flag = - 3;

	// OBBՓ˂Ă\ꍇD
	if (fc_flag != 0) {

		// OBB؂̖[OBB̃P[XD
		if (node->node0 == NULL)

			// |Sƃ{bNX̏Փ˔̋ND
			detectColPolyBox(node->BBox, obj, fc_flag, col_info);

		// ċAIɎqm[hOBB𒲂ׂD
		else {
			detectColOBBBox(obj, node->node0, col_info);
			detectColOBBBox(obj, node->node1, col_info);
		}
	}
}

// ̂ƕǂ̏Փ˂̉D
void resolveColBox(col_info *col_info)
// col_info *col_info; Փ˓_̃f[^DWl̓O[oWnŗ^ĂD
{
	float numerator, v_n, term1, term2;
	float4 v, n, r;
	float4 impulse;
	object *obj;

	// IuWFNgƏՓ˓_̖@D
	obj = col_info->obj0;
	n = col_info->nrml;

	// IuWFNg̏dS->Փ˓_̃xNgvZD
	r = col_info->pnt - obj->pos;

	// dS̊pxxNglCIuWFNg̏Փ˓_ł̑xxNgZoD
	v = obj->vel + cross(obj->omega, r);

	// ΑxZoC̖@𓾂D
	v_n = dot(n, v);

	// ͂̌vZD
	numerator = (E + 1.0f) * (- v_n);
	term1 = 1.0f / obj->mass;
	term2 = dot(n, cross(r, mulMV(obj->Iinv, cross(r, n))));
	impulse = (numerator / (term1 - term2)) * n;

	// ͂IuWFNg̑xƊpx̕ωɕϊD
	obj->vel += impulse / obj->mass;
	obj->omega += mulMV(obj->Iinv, cross(r, impulse));

	// H݂邽߂ɔʈD
	obj->pos += n * 0.1f;
}

// ̓m̏Փ˂̉D
void resolveCol(col_info *col_info)
// col_info *col_info; Փ˓_̃f[^DWl̓O[oWnŗ^ĂD
{
	float numerator, v_n, term1, term2, term3, term4;
	float4 v0, v1, n, r0, r1;
	float4 impulse;
	object *obj0, *obj1;

	// IuWFNgƏՓ˓_̖@D
	obj0 = col_info->obj0;
	obj1 = col_info->obj1;
	n = col_info->nrml;

	// IuWFNg0̏dS->Փ˓_̃xNgvZD
	r0 = col_info->pnt - obj0->pos;

	// dS̊pxxNglCIuWFNg0̏Փ˓_ł̑xxNgZoD
	v0 = obj0->vel + cross(obj0->omega, r0);

	// IuWFNg1̏dS->Փ˓_̃xNgvZD
	r1 = col_info->pnt - obj1->pos;

	// dS̊pxxNglCIuWFNg1̏Փ˓_ł̑xxNgZoD
	v1 = obj1->vel + cross(obj1->omega, r1);

	// ΑxZoC̖@𓾂D
	v_n = dot(n, (v0 - v1));

	// ͂̌vZD
	numerator = (E + 1.0f) * (- v_n);
	term1 = 1.0f / obj0->mass;
	term2 = 1.0f / obj1->mass;
	term3 = dot(n, cross(r0, mulMV(obj0->Iinv, cross(r0, n))));
	term4 = dot(n, cross(r1, mulMV(obj1->Iinv, cross(r1, n))));
	impulse = (numerator / (term1 + term2 - term3 - term4)) * n;

	// ͂IuWFNg0̑xƊpx̕ωɕϊD
	obj0->vel += impulse / obj0->mass;
	obj0->omega += mulMV(obj0->Iinv, cross(r0, impulse));

	// ͂IuWFNg1̑xƊpx̕ωɕϊD
	obj1->vel -= impulse / obj1->mass;
	obj1->omega -= mulMV(obj1->Iinv, cross(r1, impulse));

	// H݂邽߂ɔʈD
	obj0->pos += n * 0.1f;
	obj1->pos -= n * 0.1f;
}

// Փ˔ƏՓˉD
void runBounce(void)
{
	unsigned int i, j, k, num_contacts, last_num;
    object *swap;

	// \ߑSIuWFNg̉]ϊƈʒu܂Ƃ߂ċL^ĂD
	for (i = 0; i < NUM_OBJECTS; i++) {

		// obj[i]̉]ϊ̋L^D
		for (j = 0; j < 3; j++)
			h_rot_pos[i][j] = obj[i].rot[j]; 

		// obj[i]̈ʒűL^D
		h_rot_pos[i][3] = obj[i].pos;
	}
	
	// IuWFNgԂ̏Փ˔D
	num_contacts = num_col_2OBB = 0;
	for (i = 0; i < (NUM_OBJECTS - 1); i++) {
		for (j = i + 1; j < NUM_OBJECTS; j++) {

			// OBBԂ̏Փ˂D
			if (num_col_2OBB > MAX_NUM_CRASH_BBOX_PAIRS) {
				printf("Too many crashing OBB pairs are detected.");
				return;
			}

			// OBBԂ̏Փ˔D
			last_num = num_col_2OBB;
			detectColOBBs(&obj[i], obj[i].node, &obj[j], obj[j].node);


			// Փ˂D
			if (num_col_2OBB > last_num) {

                // OBBԂ̏Փˏ̋L^D
				for (k = last_num; k < num_col_2OBB; k++)
					h_col_2OBB_2obj[k] = num_contacts;

				// Փ˓_𓾂\̂ŁCOɃtOi[ĂD
				h_col_point[num_contacts].nrml.w = - 1.0f;

				// Փ˂̉\̂IuWFNg\ߊi[ĂD
				h_col_info[num_contacts].obj0 = &obj[i];
				h_col_info[num_contacts].obj1 = &obj[j];
				num_contacts++;
			}
		}
	}

	// Փ˂ĂOBB̃yAD
	if (num_col_2OBB > 0)

        // Op`|SԂGPUɂD
        launchGPUDetectColPolys(num_contacts, num_col_2OBB, h_col_2OBB_DB, h_col_2OBB_2obj, h_rot_pos, h_col_point);
        //launchCPUDetectColPolys(num_contacts, num_col_2OBB, h_col_2OBB_DB, h_col_2OBB_2obj, h_rot_pos, h_col_point);

	// ͊wvZD
	for (i = 0; i < num_contacts; i++) {

		// Փ˂oꂽD
		if (h_col_point[i].nrml.w >= 0.0f) {
			h_col_info[i].pnt = h_col_point[i].pnt;
			h_col_info[i].nrml = h_col_point[i].nrml;

			// Kv΃IuWFNg̃XbvD
			if (h_col_point[i].nrml.w > 0.5f) {
				swap = h_col_info[i].obj0;
				h_col_info[i].obj0 = h_col_info[i].obj1;
				h_col_info[i].obj1 = swap;
			}

			// ̓x[X@ɂՓ˂̉D
			resolveCol(&h_col_info[i]);
		}
	}

	// ǂƃIuWFNg̏Փ˔ƌ̓x[X@ɂՓ˂̉D
	for (i = 0; i < NUM_OBJECTS; i++) {
		h_col_info[i].obj0 = NULL;
		detectColOBBBox(&obj[i], obj[i].node, &h_col_info[i]);
		if (h_col_info[i].obj0 != NULL)
			resolveColBox(&h_col_info[i]);
	}

	// IuWFNgԕړD
	moveObjects(anim_dt);
	printf("time: %f (sec)\n", anim_time += anim_dt);
}

// Aj[V\̊ԈD
#define FRAME_SKIP 5

// \D
void display(void)
{
	unsigned int i;
	GLfloat light_pos[4];

	// e̐ݒD
	defineViewMatrix(phi, theta, window_width, window_height, 0.0);

	// Ɩ̐ݒD
	light_pos[0] = (float)eye[X];
	light_pos[1] = (float)eye[Y];
	light_pos[2] = (float)eye[Z];
	light_pos[3] = 0.0f;
	glLightfv(GL_LIGHT0, GL_POSITION, light_pos);

	// f̍ގD3ʂpӂIuWFNgɂĐ؂ւD
	GLfloat ambient[3][4]  = {{0.1f, 0.1f, 0.3f, 1.0f}, {0.3f, 0.1f, 0.1f, 1.0f}, {0.1f, 0.3f, 0.1f, 1.0f}};
	GLfloat diffuse[3][4]  = {{0.1f, 0.1f, 0.8f, 1.0f}, {0.8f, 0.1f, 0.1f, 1.0f}, {0.1f, 0.8f, 0.1f, 1.0f}};
	GLfloat specular[3][4] = {{0.7f, 0.7f, 0.7f, 1.0f}, {0.7f, 0.7f, 0.7f, 1.0f}, {0.7f, 0.7f, 0.7f, 1.0f}};
	GLfloat shininess[3] = {20.0f, 20.0f, 20.0f};

	// t[XLbvDFRAME_SKIṔCՓˌvẐ݂ŕ`悵ȂD
	for(i = 0; i < FRAME_SKIP; i++)
		runBounce();
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// tbgVF[fBOD
	glBindBuffer(GL_ARRAY_BUFFER, poly_pos_vbo);
	glVertexPointer(4, GL_FLOAT, 0, 0);
	glBindBuffer(GL_ARRAY_BUFFER, poly_normal_vbo);
    glNormalPointer(GL_FLOAT, sizeof(float) * 4, 0);
 
	// VBOւ̐؂ւD
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_NORMAL_ARRAY);

	// IuWFNg̕`D
	for (i = 0; i < NUM_OBJECTS; i++) {			

		// ړƉ]D
		glPushMatrix();
		glTranslatef(obj[i].pos.x, obj[i].pos.y, obj[i].pos.z);
		glMultMatrixf((GLfloat *)obj[i].rot);

		// |S`D
		if (polygon_mode) {

			// F̐ݒD
			glMaterialfv(GL_FRONT, GL_AMBIENT, ambient[i % 3]);
			glMaterialfv(GL_FRONT, GL_SPECULAR, specular[i % 3]);
			glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse[i % 3]); 
			glMaterialf(GL_FRONT, GL_SHININESS, shininess[i % 3]);
		
			// `D
			glDrawArrays(GL_TRIANGLES, 0, num_triangles * 3);

			// OBB`D
		} else {
			glDisable(GL_LIGHTING);
			drawBBoxes(0, 2, obj[i].node); // 2xOBB`D
			glEnable(GL_LIGHTING);
		}
		glPopMatrix();
	}
	glDisableClientState(GL_VERTEX_ARRAY);
	glDisableClientState(GL_NORMAL_ARRAY);

	// {bNX̘gŕ\D
	glDisable(GL_LIGHTING);
	glBegin(GL_LINES);	
	glVertex3dv(point[0]); glVertex3dv(point[1]);
	glVertex3dv(point[2]); glVertex3dv(point[3]);
	glVertex3dv(point[6]); glVertex3dv(point[7]);
	glVertex3dv(point[4]); glVertex3dv(point[5]);
	glVertex3dv(point[0]); glVertex3dv(point[4]);
	glVertex3dv(point[4]); glVertex3dv(point[6]);
	glVertex3dv(point[6]); glVertex3dv(point[2]);
	glVertex3dv(point[2]); glVertex3dv(point[0]);
	glVertex3dv(point[1]); glVertex3dv(point[5]);
	glVertex3dv(point[5]); glVertex3dv(point[7]);
	glVertex3dv(point[7]); glVertex3dv(point[3]);
	glVertex3dv(point[3]); glVertex3dv(point[1]);
	glEnd();
	glEnable(GL_LIGHTING);
	glutSwapBuffers();
	glutPostRedisplay();
}

// TCYD
void resize(int width, int height)
{
    window_width = width;
    window_height = height;
}

// _obt@IuWFNg̐D
void createVBO(GLuint *vbo, unsigned int size, float4 *array)
// GLuint *vbo; _obt@IuWFNgD
// unsigned int size; obt@̃TCYD
// float4 *array; _obt@Ɋi[zf[^D
{
    glGenBuffers(1, vbo);
    glBindBuffer(GL_ARRAY_BUFFER, *vbo);
	glBufferData(GL_ARRAY_BUFFER, size, array, GL_DYNAMIC_DRAW);
    glBindBuffer(GL_ARRAY_BUFFER, 0);
}

// _obt@IuWFNg̍폜D
void deleteVBO(GLuint *vbo)
// GLuint *vbo; _obt@IuWFNgD
{
    glDeleteBuffers(1, vbo);
    *vbo = 0;
}

// ㏈D
void cleanUp(void)
{
	deleteVBO(&poly_pos_vbo);
	deleteVBO(&poly_normal_vbo);
    free(h_vertex);
	free(h_vertex_to_triangle);
    free(h_normal);
    cudaFree(d_vertex);
	cudaFree(d_normal);
	cudaFree(d_col_2OBB_DB);
	cudaFree(d_col_point);

    // OBB؂̃D
	freeBBoxTree(root_node);
    cudaDeviceReset();
}

// L[{[h
void keyboad(unsigned char key, int /*x*/, int /*y*/)
{
 	switch (key) {
		case 'q':
		case 'Q':
		case '\033':
			exit(0);

			// |S\OBB\̐؂ւD
        case 'p':
        case 'P':
            polygon_mode = !polygon_mode;
            break;

			// IuWFNgʒuɐݒD
		case 'r':
        case 'R':
            setObjects();
			anim_time = 0.0f;
            break;
    }
}

// }EX̃{^D
void mouse_button(int button, int state, int x, int y)
{
	if ((state == GLUT_DOWN) && (button == GLUT_LEFT_BUTTON))
		motion_p = true;
	else if (state == GLUT_UP)
		motion_p = false;
	mouse_old_x = x;
	mouse_old_y = y;
}

// }EẌړD
void mouse_motion(int x, int y)
{
	int dx, dy;
	dx = x - mouse_old_x;
	dy = y - mouse_old_y;
	if (motion_p) {
		phi -= dx * 0.2;
		theta += dy * 0.2;
	}
	mouse_old_x = x;
	mouse_old_y = y;
	glutPostRedisplay();
}

// OpenGL֌W̏ݒD
bool initGL(void)
{
	glClearColor(0.25f, 0.25f, 0.25f, 1.0f);
    glEnable(GL_DEPTH_TEST);
	glClearDepth(1.0);
	glDepthFunc(GL_LESS);
	glEnable(GL_LIGHT0);

	// glew̏D     
    glewInit();
    if (!glewIsSupported("GL_VERSION_2_0")) {
		fprintf(stderr, "ERROR: Support for necessary OpenGL extensions missing.");
        return false;
    }

	// _obt@IuWFNg̐D
	createVBO(&poly_pos_vbo, 3 * num_triangles * sizeof(float4), h_vertex);
	createVBO(&poly_normal_vbo, 3 * num_triangles * sizeof(float4), h_normal);
	return true;
}

int main(int argc, char** argv) 
{

	// ̃f̓ǂݍ݂ƏD
	initialize();
    glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
	glutInitWindowPosition(INIT_X_POS, INIT_Y_POS);
	glutInitWindowSize(INIT_WIDTH, INIT_HEIGHT);
	glutCreateWindow("Bounce");
	glutDisplayFunc(display);
	glutReshapeFunc(resize);
	glutMouseFunc(mouse_button);
	glutMotionFunc(mouse_motion);
	glutKeyboardFunc(keyboad);
    atexit(cleanUp);

	// OpenGL֌W̏D
	if (!initGL())
		return 1;
	glutMainLoop();
	return 0;
}
